# Class SSIFilter

java.lang.Object
jakarta.servlet.GenericFilter
org.apache.catalina.ssi.SSIFilter

All Implemented Interfaces:
  `Filter, FilterConfig, Serializable`

public class SSIFilter extends GenericFilter
Filter to process SSI requests within a webpage. Mapped to a content types from within web.xml.

See Also:
  - `SSIServlet`
  - Serialized Form

## Field Summary

Fields
Modifier and Type
Field
Description
`protected boolean`
`allowExec`
Allow exec (normally blocked for security)
`protected Pattern`
`contentTypeRegEx`
regex pattern to match when evaluating content types
`protected int`
`debug`
Debug level for this servlet.
`protected Long`
`expires`
Expiration time in seconds for the doc.
`protected boolean`
`isVirtualWebappRelative`
virtual path can be webapp-relative
`protected final Pattern`
`shtmlRegEx`
default pattern for ssi filter content type matching

## Constructor Summary

Constructors
Constructor
Description
`SSIFilter()`

## Method Summary

Modifier and Type
Method
Description
`void`
`doFilter(ServletRequest request, ServletResponse response, FilterChain chain)`
The `doFilter` method of the Filter is called by the container each time a request/response pair is passed through the chain due to a client request for a resource at the end of the chain.
`void`
`init()`
Convenience method for sub-classes to save them having to call `super.init(config)`.

### Methods inherited from class GenericFilter

`getFilterConfig, getFilterName, getInitParameter, getInitParameterNames, getServletContext, init`

### Methods inherited from class Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

### Methods inherited from interface Filter

`destroy`

## Field Details

### debug

protected int debug
Debug level for this servlet.

### expires

protected Long expires
Expiration time in seconds for the doc.

### isVirtualWebappRelative

protected boolean isVirtualWebappRelative
virtual path can be webapp-relative

### contentTypeRegEx

protected Pattern contentTypeRegEx
regex pattern to match when evaluating content types

### shtmlRegEx

protected final Pattern shtmlRegEx
default pattern for ssi filter content type matching

### allowExec

protected boolean allowExec
Allow exec (normally blocked for security)

## Constructor Details

### SSIFilter

public SSIFilter()

## Method Details

### init

public void init() throws ServletException
Description copied from class: `jakarta.servlet.GenericFilter`
Convenience method for sub-classes to save them having to call `super.init(config)`. This is a NO-OP by default.

Overrides:
  `init` in class `GenericFilter`
Throws:
  `ServletException` - If an exception occurs that interrupts the Filter's normal operation

### doFilter

public void doFilter(ServletRequest request, ServletResponse response, FilterChain chain) throws IOException, ServletException
Description copied from interface: `jakarta.servlet.Filter`
The `doFilter` method of the Filter is called by the container each time a request/response pair is passed through the chain due to a client request for a resource at the end of the chain. The FilterChain passed in to this method allows the Filter to pass on the request and response to the next entity in the chain.

A typical implementation of this method would follow the following pattern:-
1. Examine the request
2. Optionally wrap the request object with a custom implementation to filter content or headers for input filtering
3. Optionally wrap the response object with a custom implementation to filter content or headers for output filtering
4. a) Either invoke the next entity in the chain using the FilterChain object (`chain.doFilter()`),
4. b) or not pass on the request/response pair to the next entity in the filter chain to block the request processing
5. Directly set headers on the response after invocation of the next entity in the filter chain.

Parameters:
  `request` - The request to process
  `response` - The response associated with the request
  `chain` - Provides access to the next filter in the chain for this filter to pass the request and response to for further processing
Throws:
  `IOException` - if an I/O error occurs during this filter's processing of the request
  `ServletException` - if the processing fails for any other reason